#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <complex.h>
#include "cconfig.h"

#define _COL  3
#define _NDIM 4
#define _NSITE   (_NTX*_NTY*_NTZ*_NTT)
#define _MAXBUF  (_COL*_COL*_NDIM*_NTX*_NTY*_NTZ*_NTT)


unsigned long ByteSwap1 (unsigned long nLongNumber)
{
   union u {unsigned long vi; unsigned char c[sizeof(unsigned long)];}; 
   union v {unsigned long ni; unsigned char d[sizeof(unsigned long)];};
   union u un; 
   union v vn; 
   un.vi = nLongNumber; 
   vn.d[0]=un.c[7]; 
   vn.d[1]=un.c[6]; 
   vn.d[2]=un.c[5]; 
   vn.d[3]=un.c[4]; 
   vn.d[4]=un.c[3]; 
   vn.d[5]=un.c[2]; 
   vn.d[6]=un.c[1]; 
   vn.d[7]=un.c[0]; 
   return (vn.ni); 
}


double plaq(double complex *uu) 
{
  double complex u12[_COL*_COL];
  double complex u41[_COL*_COL];
  double complex u1241[_COL*_COL];
  double complex u1mu[_COL*_COL];
  double complex u2nu[_COL*_COL];
  double complex u4mu[_COL*_COL];
  double complex u1nu[_COL*_COL];
  double complex tu,unit[_COL*_COL];
  int ix,iy,iz,it,ic,jc,mu,nu;
  int ix2,iy2,iz2,it2;
  int ix4,iy4,iz4,it4;
  int isx[_NDIM];
  int isy[_NDIM];
  int isz[_NDIM];
  int ist[_NDIM];
  int isite;
  int isite2;
  int isite4;
  double plq;

  unit[0+_COL*0]=1.0+0.0*I;
  unit[1+_COL*0]=0.0+0.0*I;
  unit[2+_COL*0]=0.0+0.0*I;
  unit[0+_COL*1]=0.0+0.0*I;
  unit[1+_COL*1]=1.0+0.0*I;
  unit[2+_COL*1]=0.0+0.0*I;
  unit[0+_COL*2]=0.0+0.0*I;
  unit[1+_COL*2]=0.0+0.0*I;
  unit[2+_COL*2]=1.0+0.0*I;

  isx[0] = 1;
  isx[1] = 0;
  isx[2] = 0;
  isx[3] = 0;
  isy[0] = 0;
  isy[1] = 1;
  isy[2] = 0;
  isy[3] = 0;
  isz[0] = 0;
  isz[1] = 0;
  isz[2] = 1;
  isz[3] = 0;
  ist[0] = 0;
  ist[1] = 0;
  ist[2] = 0;
  ist[3] = 1;

  plq = 0.0;

  for (ix=0;ix<_NTX;ix++) {
  for (iy=0;iy<_NTY;iy++) {
  for (iz=0;iz<_NTZ;iz++) {
  for (it=0;it<_NTT;it++) {

    for (mu=0;mu<_NDIM;mu++) {
    for (nu=0;nu<_NDIM;nu++) {
      if ( mu == nu ) continue;

      ix2 = (ix + isx[mu]) % _NTX;
      iy2 = (iy + isy[mu]) % _NTY;
      iz2 = (iz + isz[mu]) % _NTZ;
      it2 = (it + ist[mu]) % _NTT;
      ix4 = (ix + isx[nu]) % _NTX;
      iy4 = (iy + isy[nu]) % _NTY;
      iz4 = (iz + isz[nu]) % _NTZ;
      it4 = (it + ist[nu]) % _NTT;

      isite  = it  + _NTT * iz  + _NTT*_NTZ * iy  + _NTT*_NTZ*_NTY * ix;
      isite2 = it2 + _NTT * iz2 + _NTT*_NTZ * iy2 + _NTT*_NTZ*_NTY * ix2;
      isite4 = it4 + _NTT * iz4 + _NTT*_NTZ * iy4 + _NTT*_NTZ*_NTY * ix4;

      for (jc=0;jc<_COL;jc++) {
      for (ic=0;ic<_COL;ic++) {
        u1mu[ic+_COL*jc] = *(uu + ic + _COL * jc + (_COL*_COL) * isite  + (_COL*_COL)*_NSITE * mu);
        u2nu[ic+_COL*jc] = *(uu + ic + _COL * jc + (_COL*_COL) * isite2 + (_COL*_COL)*_NSITE * nu);
        u4mu[ic+_COL*jc] = *(uu + ic + _COL * jc + (_COL*_COL) * isite4 + (_COL*_COL)*_NSITE * mu);
        u1nu[ic+_COL*jc] = *(uu + ic + _COL * jc + (_COL*_COL) * isite  + (_COL*_COL)*_NSITE * nu);
      }
      }

/*
      for (ic=0;ic<_COL;ic++) {
      for (jc=0;jc<_COL;jc++) {
        tu = u1nu[ic+_COL*0]*conj(u1nu[jc+_COL*0])
           + u1nu[ic+_COL*1]*conj(u1nu[jc+_COL*1])
           + u1nu[ic+_COL*2]*conj(u1nu[jc+_COL*2]);
        tu = tu - unit[ic+_COL*jc];
        if (cabs(tu) > 1.0e-14) 
          printf("%d %d %24.14e %24.14e\n",ic,jc,creal(tu),cimag(tu));
      }
      }
*/
      

      /// u12 = u(1,mu) u(2,nu)
      for (jc=0;jc<_COL;jc++) {
      for (ic=0;ic<_COL;ic++) {
        u12[ic+_COL*jc] = u1mu[ic + _COL*0] * u2nu[0 + _COL*jc]
                        + u1mu[ic + _COL*1] * u2nu[1 + _COL*jc]
                        + u1mu[ic + _COL*2] * u2nu[2 + _COL*jc];
      }
      }

      /// u41 = u(4,mu)^+ u(1,nu)^+
      for (jc=0;jc<_COL;jc++) {
      for (ic=0;ic<_COL;ic++) {
        u41[ic+_COL*jc] = conj(u4mu[0 + _COL*ic] * u1nu[jc + _COL*0]
                             + u4mu[1 + _COL*ic] * u1nu[jc + _COL*1]
                             + u4mu[2 + _COL*ic] * u1nu[jc + _COL*2]);
      }
      }

      for (jc=0;jc<_COL;jc++) {
      for (ic=0;ic<_COL;ic++) {
        u1241[ic+_COL*jc] = u12[ic + _COL*0] * u41[0 + _COL*jc]
                          + u12[ic + _COL*1] * u41[1 + _COL*jc]
                          + u12[ic + _COL*2] * u41[2 + _COL*jc];
      }
      }

      plq = plq + creal(u1241[0+_COL*0] + u1241[1+_COL*1] + u1241[2+_COL*2]);

//      printf("%24.14e\n",plq);
    }
    }
  }
  }
  }
  }

  plq = plq/(_NSITE*_NDIM*(_NDIM-1)*_COL);
  return plq;
}

int main(int argc, char *argv[]) 
{
  double complex u[_NDIM][_NTX][_NTY][_NTZ][_NTT][_COL][_COL];
  double complex *upt;
  double complex uu;
  double complex unit[_COL][_COL];
  double complex u1[_COL][_COL];
  double complex u2[_COL][_COL];
  int  binsize;
  union dd {double db; unsigned long ul;};
  union dd vre,vim;
  unsigned long ire,iim;
  FILE *fp;
  char *lime_type;
  size_t dsize;
  int ix,iy,iz,it,ic,jc,mu;

  unit[0][0]=1.0+0.0*I;
  unit[1][0]=0.0+0.0*I;
  unit[2][0]=0.0+0.0*I;
  unit[0][1]=0.0+0.0*I;
  unit[1][1]=1.0+0.0*I;
  unit[2][1]=0.0+0.0*I;
  unit[0][2]=0.0+0.0*I;
  unit[1][2]=0.0+0.0*I;
  unit[2][2]=1.0+0.0*I;
  
  if( argc < 3 ) { 
    fprintf(stderr, "Usage: %s <input bin.dat>  <fortran file name>\n", argv[0]);
    return EXIT_FAILURE;
  }

  /* Open file */
  fp = fopen(argv[1], "r");
  if(fp == (FILE *)NULL) { 
    fprintf(stderr,"Unable to open file %s for reading\n", argv[1]);
    return EXIT_FAILURE;
  }

  for (it=0;it<_NTT;it++) {
  for (iz=0;iz<_NTZ;iz++) {
  for (iy=0;iy<_NTY;iy++) {
  for (ix=0;ix<_NTX;ix++) {
    for (mu=0;mu<_NDIM;mu++) {
      for (ic=0;ic<_COL;ic++) {
      for (jc=0;jc<_COL;jc++) {
        fread(&ire,sizeof(ire),1,fp);
        fread(&iim,sizeof(iim),1,fp);
        vre.ul = ByteSwap1(ire);
        vim.ul = ByteSwap1(iim);
        u[mu][ix][iy][iz][it][jc][ic] = vre.db + vim.db*I;
        uu = u[mu][ix][iy][iz][it][jc][ic];
        u1[jc][ic]=uu;
//        printf("%24.14e %24.14e\n",vre.db,vim.db);
      }
      }

// check unitarity
      for (ic=0;ic<_COL;ic++) {
      for (jc=0;jc<_COL;jc++) {
        uu = u1[ic][0]*conj(u1[jc][0])
           + u1[ic][1]*conj(u1[jc][1])
           + u1[ic][2]*conj(u1[jc][2]);
        uu = unit[ic][jc] - uu;
        if (cabs(uu) > 1.0e-14) 
          printf("%d %d %24.14e %24.14e\n",ic,jc,creal(uu),cimag(uu));
      }
      }


    }
  }
  }
  }
  }
  fclose(fp);

  
  upt = &(u[0][0][0][0][0][0][0]);
  binsize = (int)sizeof(u);
  printf("%24.14e %d\n",plaq(upt),binsize);


  fp = fopen(argv[2], "w");
  if(fp == (FILE *)NULL) { 
    fprintf(stderr,"Unable to open file %s for reading\n", argv[2]);
    return EXIT_FAILURE;
  }
  fwrite(&binsize,sizeof(binsize),1,fp);
  fwrite(upt,sizeof(u),1,fp);
  fwrite(&binsize,sizeof(binsize),1,fp);
  fclose(fp);
}
