program su3exp
  use lattice_class
  use su3exp_class
  implicit none
  complex(DP)::   dW(COL,COL)
  complex(DP)::    W(COL,COL)
  complex(DP)::  expW_type1(COL,COL)
  complex(DP)::  expW_type2(COL,COL)
  complex(DP):: dexpW_type1(COL,COL)
  complex(DP):: dexpW_type2(COL,COL)
 
  complex(DP)::     Wt0(COL,COL)
  complex(DP)::     Wt1(COL,COL)
  complex(DP)::  expWt0(COL,COL)
  complex(DP)::  expWt1(COL,COL)
  complex(DP)::  expW_type3(COL,COL)
  complex(DP):: dexpW_type3(COL,COL)
  real(DP) :: dt,rr,dtau
  integer :: ic,jc

  dtau = 1.0e-9_DP
  dt = 1.0e-2_DP

  dW(:,:) = Z0
  dW(1,1) = ( 1.1_DP,0.0_DP)
  dW(2,2) = (-0.1_DP,0.0_DP)
  dW(3,3) =-(dW(1,1)+dW(2,2))
  dW(1,2) = ( 0.8_DP,-2.2_DP)
  dW(1,3) = ( 1.7_DP,-1.0_DP)
  dW(2,3) = (-0.1_DP,-0.8_DP)
  dW(2,1) = conjg(dW(1,2))
  dW(3,1) = conjg(dW(1,3))
  dW(3,2) = conjg(dW(2,3))

  W(:,:) = Z0
  W(1,1) = (-0.9_DP,0.0_DP)
  W(2,2) = ( 2.8_DP,0.0_DP)
  W(3,3) =-(W(1,1)+W(2,2))
  W(1,2) = (-1.0_DP, 1.1_DP)
  W(1,3) = ( 1.5_DP, 2.0_DP)
  W(2,3) = ( 2.3_DP,-1.8_DP)
  W(2,1) = conjg(W(1,2))
  W(3,1) = conjg(W(1,3))
  W(3,2) = conjg(W(2,3))

! singluar case
!#define _GG
#ifdef _GG
  W(1,1) = CMPLX(-2.0_DP-0.00000_DP,0.0_DP, kind=DP)
  W(2,2) = CMPLX( 1.0_DP-0.00000_DP,0.0_DP, kind=DP)
  W(3,3) = CMPLX( 1.0_DP+0.00000_DP,0.0_DP, kind=DP)
  W(1,2) = CMPLX( 0.0_DP,0.0_DP, kind=DP)
  W(1,3) = CMPLX( 0.0_DP,0.0_DP, kind=DP)
  W(2,3) = CMPLX( 0.0_DP,0.0_DP, kind=DP)
  W(2,1) = conjg(W(1,2))
  W(3,1) = conjg(W(1,3))
  W(3,2) = conjg(W(2,3))
#endif

   W(:,:) = dt*W(:,:)
  dW(:,:) = dt*dW(:,:)

  do jc=1,COL
  do ic=1,COL
    write(*,'(" W[",I1,",",I1,"] =",SP,F24.16,"`32",F24.16,"`32*I")')ic,jc,W(ic,jc)
  enddo
  enddo
  write(*,*)
  do jc=1,COL
  do ic=1,COL
    write(*,'("dW[",I1,",",I1,"] =",SP,F24.16,"`32",F24.16,"`32*I")')ic,jc,dW(ic,jc)
  enddo
  enddo
  write(*,*)

  Wt0(:,:)=W(:,:)+dtau*dW(:,:)/2.0_DP
  Wt1(:,:)=W(:,:)-dtau*dW(:,:)/2.0_DP
  call get_expm_taylor_ch(Wt0,expWt0)
  call get_expm_taylor_ch(Wt1,expWt1)
  dexpW_type3(:,:)=(expWt0(:,:)-expWt1(:,:))/dtau
  write(*,*)
  write(*,'("# Cayley-Hamilton + numerical deriv")')

  do jc=1,COL
  do ic=1,COL
    write(*,'(SP,E24.16,E24.16," I, ",2E24.16," I")')Z0,dexpW_type3(ic,jc)
  enddo
  enddo
  write(*,*)

  call get_expm_taylor_ch(W,expW_type1,dW,dexpW_type1)
  write(*,*)
  write(*,'("# Cayley-Hamilton + Taylor")')

  do jc=1,COL
  do ic=1,COL
    write(*,'(SP,E24.16,E24.16," I, ",2E24.16," I")')expW_type1(ic,jc),dexpW_type1(ic,jc)
  enddo
  enddo
  write(*,*)

  call get_expm_explicit(W,expW_type2,dW,dexpW_type2)
  write(*,*)
!  write(*,'("# Taylor expansion")')
  write(*,'("# Explicit Formula")')

  do jc=1,COL
  do ic=1,COL
    write(*,'(SP,E24.16,E24.16," I, ",2E24.16," I")')expW_type2(ic,jc),dexpW_type2(ic,jc)
  enddo
  enddo
  write(*,*)

  rr=0.0_DP
  do ic=1,COL
  do jc=1,COL
    rr = rr + ABS(expW_type1(ic,jc)-expW_type2(ic,jc))
  enddo
  enddo
  write(*,'("# sum_{i,j}|expW_type1(i,j)-expW_type2(i,j)|=",E24.16)')rr
  write(*,*)
  rr=0.0_DP
  do ic=1,COL
  do jc=1,COL
    rr = rr + ABS(dexpW_type1(ic,jc)-dexpW_type2(ic,jc))
  enddo
  enddo
  write(*,'("# sum_{i,j}|dexpW_type1(i,j)-dexpW_type2(i,j)|=",E24.16)')rr
  write(*,*)

  write(*,'("# expW_type1(i,j)-exp_type2(i,j)")')
  do jc=1,COL
  do ic=1,COL
    write(*,'(SP,E24.16,E24.16," I")')expW_type1(ic,jc)-expW_type2(ic,jc)
  enddo
  enddo
  write(*,*)
  write(*,'("# dexpW_type1(i,j)-dexp_type2(i,j)")')
  do jc=1,COL
  do ic=1,COL
    write(*,'(SP,E24.16,E24.16," I")')dexpW_type1(ic,jc)-dexpW_type2(ic,jc)
  enddo
  enddo
  write(*,*)

  write(*,'("# Unitarity expW_type1")')
  W(:,:) = MATMUL(expW_type1(:,:),CONJG(TRANSPOSE(expW_type1(:,:))))
  do jc=1,COL
  do ic=1,COL
    write(*,'(SP,E24.16,E24.16," I")')W(ic,jc)
  enddo
  enddo
  write(*,*)

  write(*,'("# Unitarity expW_type2")')
  W(:,:) = MATMUL(expW_type2(:,:),CONJG(TRANSPOSE(expW_type2(:,:))))
  do jc=1,COL
  do ic=1,COL
    write(*,'(SP,E24.16,E24.16," I")')W(ic,jc)
  enddo
  enddo

  stop
end program
